## unifrac 0.10.0

=== sucpp/Makefile ===
CXX := h5c++

PLATFORM := $(shell uname -s)
COMPILER := $(shell ($(CXX) -v 2>&1) | tr A-Z a-z )

ifdef DEBUG
	OPT = -O0 -DDEBUG=1 --debug -g -ggdb
else
	ifneq (,$(findstring gcc,$(COMPILER)))
		OPT = -O4
		TGTFLAGS = -fwhole-program
	else
		OPT = -O3
	endif
endif

ifeq ($(PREFIX),)
	PREFIX := $(CONDA_PREFIX)
endif

ifeq ($(PLATFORM),Darwin)
	AVX2 := $(shell sysctl -a | grep -c AVX2)
	LDDFLAGS = -dynamiclib -install_name @rpath/libssu.so
else
	AVX2 := $(shell grep "^flags" /proc/cpuinfo | head -n 1 | grep -c avx2)
	LDDFLAGS = -shared
endif

ifeq ($(PERFORMING_CONDA_BUILD),True)
	CPPFLAGS += -mtune=generic
else
	CPPFLAGS += -mfma -march=native
endif

CPPFLAGS += -Wall -Wextra -std=c++11 -pedantic -I. $(OPT) -fPIC

test: tree.o test_su.cpp biom.o unifrac.o unifrac_task.o api.o
	$(CXX) $(CPPFLAGS) -Wno-unused-parameter test_su.cpp -o test_su tree.o biom.o unifrac.o unifrac_task.o api.o -pthread
	$(CXX) $(CPPFLAGS) -Wno-unused-parameter test_api.cpp -o test_api tree.o biom.o unifrac.o unifrac_task.o api.o -pthread

main: tree.o biom.o unifrac.o cmd.o unifrac_task.o api.o
	$(CXX) $(CPPFLAGS) su.cpp -o ssu tree.o biom.o unifrac.o cmd.o unifrac_task.o api.o -lhdf5_cpp -pthread
	$(CXX) $(CPPFLAGS) faithpd.cpp -o faithpd tree.o biom.o unifrac.o cmd.o unifrac_task.o api.o -lhdf5_cpp -pthread
	cp ssu ${PREFIX}/bin/
	cp faithpd ${PREFIX}/bin/

rapi_test: main
	mkdir -p ~/.R
	if [ -a ~/.R/Makevars ] ; \
	then \
		echo "WARNING: OVERWRITING ~/.R/Makevars" ; \
		echo "The original Makevars file has been copied to ~/.R/Makevars" ;\
		cp ~/.R/Makevars Makevars-original ; \
	fi;
	echo CXX1X=h5c++ > ~/.R/Makevars
	echo CXX=h5c++ >> ~/.R/Makevars 
	echo CC=h5c++ >> ~/.R/Makevars
	Rscript R_interface/rapi_test.R
	
api: tree.o biom.o unifrac.o cmd.o unifrac_task.o
	$(CXX) $(CPPFLAGS) api.cpp -c -o api.o -fPIC
	$(CXX) $(LDDFLAGS) -o libssu.so tree.o biom.o unifrac.o cmd.o unifrac_task.o api.o -lc -lhdf5_cpp -L$(PREFIX)/lib
	cp libssu.so ${PREFIX}/lib/

capi_test: api
	gcc -std=c99 capi_test.c -lssu -L${PREFIX}/lib -Wl,-rpath,${PREFIX}/lib -o capi_test
	export LD_LIBRARY_PATH="${PREFIX}/lib":"./capi_test"

%.o: %.cpp %.hpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

clean:
	-rm -f *.o ssu

=== debian/changelog ===
unifrac (0.10.0-3build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 17:42:25 +0000

unifrac (0.10.0-3) unstable; urgency=medium

  * Team Upload.
  * d/rules: better clean-up
  * removed -mfma to avoid illegal instruction error on older machines

 -- Steffen Moeller <moeller@debian.org>  Tue, 14 Sep 2021 17:39:15 +0530

unifrac (0.10.0-2) unstable; urgency=medium

  * Strip out rpath via chrpath
  * d/salsa-ci.yml: Enable lintian

 -- Nilesh Patra <nilesh@debian.org>  Sat, 24 Jul 2021 20:05:50 +0530

unifrac (0.10.0-1) unstable; urgency=medium

  * Initial release (Closes: #991458)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 24 Jul 2021 19:13:14 +0530

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=unifrac

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:`pwd`/sucpp dh_auto_test -O --buildsystem=pybuild
endif

execute_after_dh_install:
	chrpath -d debian/libssu-tools/usr/bin/ssu
	chrpath -d debian/libssu-tools/usr/bin/faithpd
	chrpath -d debian/libssu0/usr/lib/$(DEB_HOST_MULTIARCH)/libssu.so.0

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.o" -delete
	rm -rf .pybuild/ build/ sucpp/ssu unifrac/_api.cpp sucpp/test_su sucpp/test_api sucpp/libssu.so.0 sucpp/faithpd sucpp/libssu.so
	rm -rf unifrac.egg-info

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/biocore/unifrac/releases .*/archive/.*/v?@ANY_VERSION@\.tar\.gz

## unifrac 1.1.1

=== debian/changelog ===
unifrac (1.1.1-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/rules: better clean-up
  * removed -mfma to avoid illegal instruction error on older machines

  [ Andreas Tille ]
  * New upstream version
  * Add myself to Uploaders and remove Nilesh
    Closes: #996921
  * Standards-Version: 4.6.1 (routine-update)
  * Now depends from libssu-dev provided by unifrac-tools
  * Build-Depends: python3-iow
  * Hardening
  * Versioned Build-Depends: python3-iow (>= 1.0.5-3)

  [ Étienne Mollier ]
  * d/t/run-unit-test: run from within unifrac directory.

 -- Andreas Tille <tille@debian.org>  Thu, 17 Nov 2022 06:34:11 +0100

=== debian/control ===
Source: unifrac
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-python,
               python3-all-dev,
               python3-setuptools,
               python3-numpy,
               cython3,
               libhdf5-dev,
               hdf5-helpers,
               python3-h5py,
               python3-biom-format,
               python3-skbio <!nocheck>,
               python3-iow (>= 1.0.5-3) <!nocheck>,
               libssu-dev (>= 1.1.1)
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/unifrac
Vcs-Git: https://salsa.debian.org/med-team/unifrac.git
Homepage: https://github.com/biocore/unifrac
Rules-Requires-Root: no

Package: python3-unifrac
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Description: high-performance phylogenetic diversity calculations
 The de facto repository for high-performance phylogenetic diversity
 calculations. The methods in this repository are based on an
 implementation of the Strided State UniFrac algorithm which is faster,
 and uses less memory than Fast UniFrac. Strided State UniFrac supports
 Unweighted UniFrac, Weighted UniFrac, Generalized UniFrac, Variance
 Adjusted UniFrac and meta UniFrac. This repository also includes Stacked
 Faith (manuscript in preparation), a method for calculating Faith's PD
 that is faster and uses less memory than the Fast UniFrac-based
 reference implementation.
 .
 This package contains the Python3 module.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/biocore/unifrac/releases .*/.*/v?@ANY_VERSION@\.tar\.gz

## unifrac 1.2

=== debian/changelog ===
unifrac (1.2-3) unstable; urgency=medium

  * Versioned Build-Depends: python3-skbio (>= 0.5.8-3~)
    Closes: #1030182

 -- Andreas Tille <tille@debian.org>  Wed, 01 Feb 2023 13:47:44 +0100

unifrac (1.2-2) unstable; urgency=medium

  * Relax some tests to pass on ppc64el

 -- Andreas Tille <tille@debian.org>  Mon, 09 Jan 2023 09:15:43 +0100

unifrac (1.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

  [ Nilesh Patra ]
  * Versioned B-D on ssu and skbio

 -- Andreas Tille <tille@debian.org>  Thu, 05 Jan 2023 21:51:22 +0530

unifrac (1.1.1-2) unstable; urgency=medium

  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Wed, 30 Nov 2022 08:47:28 +0100

=== debian/control ===
--- 
+++ 
@@ -15,10 +15,10 @@
                hdf5-helpers,
                python3-h5py,
                python3-biom-format,
-               python3-skbio <!nocheck>,
-               python3-iow (>= 1.0.5-3) <!nocheck>,
-               libssu-dev (>= 1.1.1)
-Standards-Version: 4.6.1
+               python3-skbio (>= 0.5.8-3~) <!nocheck>,
+               python3-iow <!nocheck>,
+               libssu-dev (>= 1.2-1~)
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/unifrac
 Vcs-Git: https://salsa.debian.org/med-team/unifrac.git
 Homepage: https://github.com/biocore/unifrac

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export PYBUILD_NAME=unifrac

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf unifrac.egg-info unifrac/_api.c

## unifrac 1.3

=== debian/changelog ===
unifrac (1.3-2build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 09:52:50 +0000

unifrac (1.3-2) unstable; urgency=medium

  * execute dh_numpy3 after dh_python3 to assign python3-numpy-abi
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Drop cython3 dependency from binary package
    Closes: #1058015

 -- Andreas Tille <tille@debian.org>  Sun, 17 Dec 2023 21:02:39 +0100

unifrac (1.3-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team Upload.
  * New upstream version
  * Bump versioned Build-Depends: libssu-dev (>= 1.3.2-1~)

  [ Nilesh Patra ]
  * Relax test conditions on test_unweighted_minimal_trees to get
    tests passing (Closes: #1042198)
  * Add versioned dep on libssu-dev (1.4-2~) to get faith_pd test fixed

 -- Nilesh Patra <nilesh@debian.org>  Tue, 24 Oct 2023 04:20:14 +0530

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-exec,
-               dh-python,
+               dh-sequence-python3,
                python3-all-dev,
                python3-setuptools,
                python3-numpy,
@@ -17,7 +17,7 @@
                python3-biom-format,
                python3-skbio (>= 0.5.8-3~) <!nocheck>,
                python3-iow <!nocheck>,
-               libssu-dev (>= 1.2-1~)
+               libssu-dev (>= 1.4-2~)
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/unifrac
 Vcs-Git: https://salsa.debian.org/med-team/unifrac.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export PYBUILD_NAME=unifrac

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf unifrac.egg-info unifrac/_api.c

override_dh_python3:
	dh_python3
	dh_numpy3

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, python3-all, build-essential
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/biocore/unifrac/tags .*/v?@ANY_VERSION@\.tar\.gz
